diff -uNrd ircd-hybrid-6.dist/include/config.h ircd-hybrid-6/include/config.h
--- ircd-hybrid-6.dist/include/config.h	Sun Dec 15 21:30:05 2002
+++ ircd-hybrid-6/include/config.h	Sun Dec 15 21:37:56 2002
@@ -336,6 +336,13 @@
 #undef  O_LINES_OPER_ONLY
 #define P_LINES_OPER_ONLY
 #undef  U_LINES_OPER_ONLY
+#undef  C_LINES_OPER_ONLY
+
+/* STATS_QMARK_OPER_ONLY - Block /stats ? from non opers.  This is not
+ * recommended, as it makes it harder for opers to check on a link when
+ * they cannot connect to their oper server.
+ */
+#undef  STATS_QMARK_OPER_ONLY
 
 /* SPOOF_NOTICE - See a notice when a user connects with a
  * spoofed I: line
diff -uNrd ircd-hybrid-6.dist/include/config.h.dist ircd-hybrid-6/include/config.h.dist
--- ircd-hybrid-6.dist/include/config.h.dist	Sun Dec 15 21:30:05 2002
+++ ircd-hybrid-6/include/config.h.dist	Sun Dec 15 21:38:16 2002
@@ -336,6 +336,13 @@
 #undef  O_LINES_OPER_ONLY
 #define P_LINES_OPER_ONLY
 #undef  U_LINES_OPER_ONLY
+#undef  C_LINES_OPER_ONLY
+
+/* STATS_QMARK_OPER_ONLY - Block /stats ? from non opers.  This is not
+ * recommended, as it makes it harder for opers to check on a link when
+ * they cannot connect to their oper server.
+ */
+#undef  STATS_QMARK_OPER_ONLY
 
 /* SPOOF_NOTICE - See a notice when a user connects with a
  * spoofed I: line
diff -uNrd ircd-hybrid-6.dist/src/m_stats.c ircd-hybrid-6/src/m_stats.c
--- ircd-hybrid-6.dist/src/m_stats.c	Sun Dec 15 21:30:05 2002
+++ ircd-hybrid-6/src/m_stats.c	Sun Dec 15 21:36:05 2002
@@ -273,14 +273,13 @@
       valid_stats++;
       break;
     case 'C' : case 'c' :
-#ifdef SERVERHIDE
+#if defined(SERVERHIDE) || defined(C_LINES_OPER_ONLY)
       if (!IsAnOper(sptr))
         {
           ignore_request++;
           valid_stats++;
           break;
         }
-      else
 #endif
       report_configured_links(sptr, CONF_CONNECT_SERVER|CONF_NOCONNECT_SERVER);
       valid_stats++;
@@ -331,7 +330,6 @@
           valid_stats++;
           break;
         }
-      else
 #endif
       report_configured_links(sptr, CONF_HUB|CONF_LEAF);
       valid_stats++;
@@ -538,6 +536,14 @@
       break;
 
     case '?':
+#ifdef STATS_QMARK_OPER_ONLY
+      if (!IsAnOper(sptr))
+        {
+          ignore_request++;
+          valid_stats++;
+          break;
+        }
+#endif /* STATS_QMARK_OPER_ONLY */
       serv_info(sptr, parv[0]);
       valid_stats++;
       break;
